var urlBaseApi = "https://gerarcertificado.com.br/API/";
var b64ModeloNovo = "";

var gerando = false;
var gerandoLote = false;
var saldoUsuario = 0;

var idModeloSelecionado = 0;
var alunos = new Array();
var qtdAlunos = 0;
var dadosCursoValidados = false;
var tcert = '';

var palestraTitulo = "";
var palestraProfessor = "";
var palestraData = "";
var palestraLocal = "";
var palestraCargaHoraria = "";

//dados reais edição modelo
var pixelEm1Cm = 56;
var wCertificadoReal = 1811;
var hCertificadoReal = 1299;
var mSuperiorRealCm = 0;
var mInferiorRealCm = 0;
var mEsquerdaRealCm = 0;
var mDireitaRealCm = 0;

//dados simulados
var mSuperiorRealPx = (mSuperiorRealCm/10)*pixelEm1Cm;
var mInferiorRealPx = (mInferiorRealCm/10)*pixelEm1Cm;
var mEsquerdaRealPx = (mEsquerdaRealCm/10)*pixelEm1Cm;
var mDireitaRealPx = (mDireitaRealCm/10)*pixelEm1Cm;
var wCertificadoSimulado = 0;
var hCertificadoSimulado = 0;
var mSuperiorSimulado = 0;
var mInferiorSimulado = 0;
var mEsquerdaSimulado = 0;
var mDireitaSimulado = 0;
var wTextoSimulado = 0;
var hTextoSimulado = 0;

function initAplicacao(){
    jQuery('.page-login').removeClass('open');
    jQuery('.aplicacao').removeClass('close');
    getSaldoUsuario();
    getModelos();
}

function login(email, senha){
    var token = btoa(email + ":" + senha);
    jQuery.ajax({
        type: "POST",
        url: urlBaseApi + "auth/V1/",
        dataType: 'json',
        beforeSend: function (xhr) {
            xhr.setRequestHeader("Authorization", "Basic " + token);
        }
    }).done(function(data) {
        localStorage.setItem('pgc-token', token);
        initAplicacao();
    }).fail(function() {
        alert('Dados de login não conferem');
    });
}

function solicitaLogin(){
    jQuery('.page-login').addClass('open');
    jQuery('.aplicacao').addClass('close');
}

function getToken(){
    if(localStorage.getItem('pgc-token') != undefined){
        return localStorage.getItem('pgc-token');
    } else {
        solicitaLogin();
        return false;
    }    
}

function getSaldoUsuario(){
    jQuery('#sua-conta .saldo').html('Consultando...');
    jQuery('#sua-conta .saldoDiv2').html('');
    if(getToken()) {
        jQuery.ajax({
            type: "POST",
            url: urlBaseApi + "credits/V1/",
            dataType: 'json',
            beforeSend: function (xhr) {
                xhr.setRequestHeader("Authorization", "Basic " + getToken());
            }
        }).done(function(data) {
            saldoUsuario = data[0].credits;
            jQuery('#sua-conta .saldo').html(saldoUsuario);
            jQuery('#sua-conta .saldoDiv2').html(Math.floor((saldoUsuario/2)));
        }).fail(function() {
            solicitaLogin();
        });
    } else {
        solicitaLogin();
    }
}

function getModelos(funcaoCallback = null){
    jQuery('#modelos .certificados').empty();
    jQuery('#modelos_usuario .certificados').empty();
    if(getToken()) {
        jQuery.ajax({
            type: "POST",
            url: urlBaseApi + "models/getAll/V1/",
            dataType: 'json',
            beforeSend: function (xhr) {
                xhr.setRequestHeader("Authorization", "Basic " + getToken());
            }
        }).done(function(data) {
            jQuery.each(data[0].models.publics, function(index, arrCertificado){
                var elem =  '<div id="certificado-' + arrCertificado.id + '" class="certificado" onclick="selecionaCertificado(' + arrCertificado.id + ')">';
                    elem += '<img src="' + arrCertificado.thumb + '"/>';
                    elem += '<div class="nome">';
                    elem += '<span class="dashicons dashicons-yes"></span> ' + arrCertificado.nome;
                    elem += '</div>';
                    elem += '</div>';
                jQuery(elem).appendTo('#modelos .certificados');    
            });
            jQuery.each(data[0].models.privates, function(index, arrCertificado){
                var elem =  '<div id="certificado-' + arrCertificado.id + '" class="certificado" onclick="selecionaCertificado(' + arrCertificado.id + ')">';
                    elem += '<img src="' + arrCertificado.thumb + '"/>';
                    elem += '<a class="btn btn-xs btn-danger excluir" title="Excluir este modelo" onclick="excluirModelo(' + arrCertificado.id + ')">';
                    elem += '<span class="dashicons dashicons-trash"></span>';
                    elem += '</a>';
                    elem += '<div class="nome">';
                    elem += '<span class="dashicons dashicons-yes"></span> ' + arrCertificado.nome + '<br/>';
                    elem += '<a class="editar" onclick="editarModelo(' + arrCertificado.id + ')">';
                    elem += '<span class="dashicons dashicons-edit" aria-hidden="true"></span> Editar preferências';
                    elem += '</a>';
                    elem += '</div>';
                    elem += '</div>';
                jQuery(elem).appendTo('#modelos_usuario .certificados');    
            });
            if(funcaoCallback !== null){
                eval(funcaoCallback);
            }
        }).fail(function() {
            solicitaLogin();
        });
    }
}

jQuery('#input-form-modelo').on('change', function(){
    const file = jQuery(this)[0].files[0];
    const fileReader = new FileReader();
    fileReader.onloadend = function(){        
        //se tiver mais de 250kb
        if(file.size > 250000){
            alert('arquivo muito grande')
        }
        //se não for jpg
        if(file.type != "image/jpeg") {
            alert('arquivo precisa estar no formato JPG')
        }
        //ativa envio ou não
        if(file.size > 500000 || file.type != "image/jpeg"){
            jQuery('#form-novo-modelo button[type="submit"]').attr('disabled','disabled');
            b64ModeloNovo = "";
        } else {
            jQuery('#form-novo-modelo button[type="submit"]').removeAttr('disabled');
            b64ModeloNovo = fileReader.result;
        }            
    }
    fileReader.readAsDataURL(file);
});

function informarCadastroModelo(){
    jQuery('.aplicacao .abas #modelos_usuario #btn-cadastro-modelo').hide();
    jQuery('.aplicacao .abas #modelos_usuario #form-novo-modelo').show();
}

function criaModeloNovo(){
    if(getToken() && b64ModeloNovo != "") {
        jQuery.ajax({
            type: "POST",
            url: urlBaseApi + "models/create/V1/",
            dataType: 'json',
            beforeSend: function (xhr) {
                xhr.setRequestHeader("Authorization", "Basic " + getToken());
            },
            data: {b64: b64ModeloNovo}            
        }).done(function(data) {
            getModelos('editarModelo(' + data[0] + ')');
            jQuery('.aplicacao .abas #modelos_usuario #btn-cadastro-modelo').show();
            jQuery('.aplicacao .abas #modelos_usuario #form-novo-modelo').hide();
        }).fail(function() {
            solicitaLogin();
        });
    }
}

function editarModelo(idCertificado){
    jQuery('#myModal').modal('show');
    if(getToken() && idCertificado != "") {
        jQuery.ajax({
            type: "POST",
            url: urlBaseApi + "models/getById/V1/",
            dataType: 'json',
            beforeSend: function (xhr) {
                xhr.setRequestHeader("Authorization", "Basic " + getToken());
            },
            data: {idModel: idCertificado}            
        }).done(function(data) {

            jQuery('#myModal .modal-title').html('Editar preferências do modelo');
            jQuery('#myModal .modal-footer button#salvar').attr('onclick','salvarModelo(' + idCertificado + ')');
            jQuery('#myModal #margem_superior').val(data[0].marginTop);
            jQuery('#myModal #margem_inferior').val(data[0].marginBottom); 
            jQuery('#myModal #margem_esquerda').val(data[0].marginLeft);
            jQuery('#myModal #margem_direita').val(data[0].marginRight);
            jQuery('#myModal #nome').val(data[0].name);
            jQuery('#myModal #cor').val(data[0].textColor);
            jQuery('#myModal .texto-modelo-simulado').css('color', data[0].textColor);
            jQuery('#myModal img#img-modelo').attr('src', data[0].image);

            mSuperiorRealCm = parseInt(data[0].marginTop);
            mInferiorRealCm = parseInt(data[0].marginBottom);
            mEsquerdaRealCm = parseInt(data[0].marginLeft);
            mDireitaRealCm = parseInt(data[0].marginRight);

            setTimeout(function(){
                calculaPosicaoTexto();
            },1000);  
        
            jQuery(window).resize(function(){
                calculaPosicaoTexto();
            });

        }).fail(function() {
            solicitaLogin();
        });
    }
}

function salvarModelo(idCertificado){
    jQuery('#myModal').modal('hide');
    if(getToken() && idCertificado != "") {
        var marginTop = jQuery('#myModal #margem_superior').val();
        var marginBottom = jQuery('#myModal #margem_inferior').val(); 
        var marginLeft = jQuery('#myModal #margem_esquerda').val();
        var marginRight = jQuery('#myModal #margem_direita').val();
        var name = jQuery('#myModal #nome').val();
        var textColor = jQuery('#myModal #cor').val();
        jQuery.ajax({
            type: "POST",
            url: urlBaseApi + "models/edit/V1/",
            dataType: 'json',
            beforeSend: function (xhr) {
                xhr.setRequestHeader("Authorization", "Basic " + getToken());
            },
            data: {idModeloCertificado: idCertificado, margemSuperior: marginTop, margemInferior: marginBottom, margemEsquerda: marginLeft, margemDireita: marginRight, nome: name, corTextos: textColor}            
        }).done(function(data) {
            getModelos('selecionaCertificado(' + idCertificado + ')');
        }).fail(function() {
            solicitaLogin();
        });
    }
}

function calculaPosicaoTexto(){
    mSuperiorRealPx = (mSuperiorRealCm/10)*pixelEm1Cm;
    mInferiorRealPx = (mInferiorRealCm/10)*pixelEm1Cm;
    mEsquerdaRealPx = (mEsquerdaRealCm/10)*pixelEm1Cm;
    mDireitaRealPx = (mDireitaRealCm/10)*pixelEm1Cm;
    wCertificadoSimulado = jQuery('.modelo-simulado').width();
    hCertificadoSimulado = jQuery('.modelo-simulado').height();
    mSuperiorSimulado = (mSuperiorRealPx*hCertificadoSimulado)/hCertificadoReal;
    mInferiorSimulado = (mInferiorRealPx*hCertificadoSimulado)/hCertificadoReal;
    mEsquerdaSimulado = (mEsquerdaRealPx*wCertificadoSimulado)/wCertificadoReal;
    mDireitaSimulado = (mDireitaRealPx*wCertificadoSimulado)/wCertificadoReal;
    wTextoSimulado = wCertificadoSimulado-mEsquerdaSimulado-mDireitaSimulado;
    hTextoSimulado = hCertificadoSimulado-mSuperiorSimulado-mInferiorSimulado;
    jQuery('.modelo-simulado .texto-modelo-simulado').css({opacity: 1, width: wTextoSimulado, height: hTextoSimulado, top: mSuperiorSimulado, left: mEsquerdaSimulado});
}

function moverTextos(direcao){
    var cmMovimentacao = 0.5;
    if(direcao == "up"){
        mSuperiorRealCm = parseInt(mSuperiorRealCm)-(cmMovimentacao*10);
        mInferiorRealCm = parseInt(mInferiorRealCm)+(cmMovimentacao*10);
        if(mSuperiorRealCm < (cmMovimentacao*10)){
            mSuperiorRealCm = cmMovimentacao*10;
            mInferiorRealCm = parseInt(mInferiorRealCm)-(cmMovimentacao*10);
        }
        jQuery('input[name="margem_superior"]').val(mSuperiorRealCm);
        jQuery('input[name="margem_inferior"]').val(mInferiorRealCm);
    }
    if(direcao == "down"){
        mInferiorRealCm = parseInt(mInferiorRealCm)-(cmMovimentacao*10);
        mSuperiorRealCm = parseInt(mSuperiorRealCm)+(cmMovimentacao*10);            
        if(mInferiorRealCm < (cmMovimentacao*10)){
            mInferiorRealCm = cmMovimentacao*10;
            mSuperiorRealCm = parseInt(mSuperiorRealCm)-(cmMovimentacao*10);
        }
        jQuery('input[name="margem_inferior"]').val(mInferiorRealCm);
        jQuery('input[name="margem_superior"]').val(mSuperiorRealCm);
    }
    if(direcao == "left"){
        mEsquerdaRealCm = parseInt(mEsquerdaRealCm)-(cmMovimentacao*10);
        mDireitaRealCm = parseInt(mDireitaRealCm)+(cmMovimentacao*10);
        if(mEsquerdaRealCm < (cmMovimentacao*10)){
            mEsquerdaRealCm = cmMovimentacao*10;
            mDireitaRealCm = parseInt(mDireitaRealCm)-(cmMovimentacao*10);
        }
        jQuery('input[name="margem_esquerda"]').val(mEsquerdaRealCm);
        jQuery('input[name="margem_direita"]').val(mDireitaRealCm);
    }
    if(direcao == "right"){
        mDireitaRealCm = parseInt(mDireitaRealCm)-(cmMovimentacao*10);
        mEsquerdaRealCm = parseInt(mEsquerdaRealCm)+(cmMovimentacao*10);            
        if(mDireitaRealCm < (cmMovimentacao*10)){
            mDireitaRealCm = cmMovimentacao*10;
            mEsquerdaRealCm = parseInt(mEsquerdaRealCm)-(cmMovimentacao*10);
        }
        jQuery('input[name="margem_direita"]').val(mDireitaRealCm);
        jQuery('input[name="margem_esquerda"]').val(mEsquerdaRealCm);            
    }
    calculaPosicaoTexto();
}

function alteraCorTexto(){
    var novaCor = jQuery('input#cor').val();
    jQuery('.modelo-simulado .texto-modelo-simulado').css({color: novaCor});
}

function excluirModelo(idModelo){
    if(getToken() && idModelo > 0 && confirm('Deseja mesmo excluir este modelo?')) {
        jQuery.ajax({
            type: "POST",
            url: urlBaseApi + "models/delete/V1/",
            dataType: 'json',
            beforeSend: function (xhr) {
                xhr.setRequestHeader("Authorization", "Basic " + getToken());
            },
            data: {idModel: idModelo}            
        }).done(function(data) {
            idModeloSelecionado = 0;
            getModelos();
        }).fail(function() {
            solicitaLogin();
        });
    }
}

function selecionaPasso(passo){
    if(passo > 0){
        jQuery('.nav-abas .nav-aba').removeClass('current');
        jQuery('.abas .aba').removeClass('current');
        jQuery('.acoes .btn').removeClass('atencao');
        jQuery('.nav-abas #nav-aba-' + passo).addClass('current');
        jQuery('.abas #aba-' + passo).addClass('current');
        passosCompletos();
        if(passo == 4){
            contaCreditosAUtilizar();
        }
        jQuery('#preview a.btn-preview').removeClass('atencao');
        setTimeout(function(){
            jQuery('#preview a.btn-preview').addClass('atencao');
        }, 2000);
    }
}

function passosCompletos(){   
    if(idModeloSelecionado > 0){
        jQuery('.nav-abas #nav-aba-1').addClass('ok');
        jQuery('.nav-abas #nav-aba-2').addClass('habilitado').attr('onclick','selecionaPasso(2)');
        jQuery('.acoes .btn-to-2').removeClass('desabilitado').addClass('atencao').attr('onclick','selecionaPasso(2)');;                
    } else {
        jQuery('.nav-abas #nav-aba-1').removeClass('ok');
        jQuery('.nav-abas #nav-aba-2').removeClass('ok').removeClass('habilitado').removeAttr('onclick');
        jQuery('.nav-abas #nav-aba-3').removeClass('ok').removeClass('habilitado').removeAttr('onclick');
        jQuery('.nav-abas #nav-aba-4').removeClass('ok').removeClass('habilitado').removeAttr('onclick');
        jQuery('.acoes .btn-to-2').addClass('desabilitado').removeClass('atencao').removeAttr('onclick');
    }
    if(idModeloSelecionado > 0 && qtdAlunos > 0){
        jQuery('.nav-abas #nav-aba-2').addClass('ok');
        jQuery('.nav-abas #nav-aba-3').addClass('habilitado').attr('onclick','selecionaPasso(3)');
        jQuery('.acoes .btn-to-3').removeClass('desabilitado').addClass('atencao').attr('onclick','selecionaPasso(3)');;
    } else {
        jQuery('.nav-abas #nav-aba-2').removeClass('ok');
        jQuery('.nav-abas #nav-aba-3').removeClass('ok').removeClass('habilitado').removeAttr('onclick');
        jQuery('.nav-abas #nav-aba-4').removeClass('ok').removeClass('habilitado').removeAttr('onclick');
        jQuery('.acoes .btn-to-3').addClass('desabilitado').removeClass('atencao').removeAttr('onclick');
    }
    if(idModeloSelecionado > 0 && qtdAlunos > 0 && dadosCursoValidados == true){
        jQuery('.nav-abas #nav-aba-3').addClass('ok'); 
        jQuery('.nav-abas #nav-aba-4').addClass('habilitado').attr('onclick','selecionaPasso(4)');
        jQuery('.aplicacao .abas .aba .acoes #btn-passo-final').removeClass('desabilitado').attr('onclick','selecionaPasso(4)');
        jQuery('.acoes .btn-to-4').addClass('atencao');
    } else {
        jQuery('.nav-abas #nav-aba-3').removeClass('ok');
        jQuery('.nav-abas #nav-aba-4').removeClass('habilitado').removeAttr('onclick');
        jQuery('.aplicacao .abas .aba .acoes #btn-passo-final').addClass('desabilitado').removeAttr('onclick');
        jQuery('.acoes .btn-to-4').removeClass('atencao');
    }
}

function selecionaCertificado(idCertificado){
    if(idCertificado > 0){
        jQuery('.acoes .btn-to-2').removeClass('atencao');
        jQuery('.certificados .certificado').removeClass('selecionado');
        jQuery('.certificados #certificado-' + idCertificado).addClass('selecionado');
        idModeloSelecionado = idCertificado;
        jQuery('html, body').animate({ 
            scrollTop: jQuery('html').height()
        }, 500, function(){
            passosCompletos();
        });
        jQuery('#preview a.btn-preview').removeAttr('disabled').addClass('atencao');
    }
}

function verificaQtdAlunos(){
    qtdAlunos = alunos.length;
    passosCompletos();
}

function botoesCadastroManual(){
    if(jQuery('#form-manual-aluno .dados').length == 1){
        jQuery('#form-manual-aluno .dados:first-of-type button.remove').hide();
        jQuery('#form-manual-aluno .dados:first-of-type button.add').show();
    } else {
        jQuery('#form-manual-aluno .dados button.remove').show();
        jQuery('#form-manual-aluno .dados button.add').hide();
        jQuery('#form-manual-aluno .dados:last-of-type button.add').show();
    }
}

function addLinhaCadastroManual(withFocus = true){
    if(!withFocus){
        if(jQuery('#form-manual-aluno .dados:last-of-type input[name="nome"]').val() == "" && jQuery('#form-manual-aluno .dados:last-of-type input[name="email"]').val() == ""){
            return false;
        }
    }
    jQuery('#form-manual-aluno .dados:last-of-type').clone().appendTo('#form-manual-aluno #dados').find('input').val('');
    if(withFocus) {
        jQuery('#form-manual-aluno .dados:last-of-type input[type=text]').focus();
    }
    botoesCadastroManual();
}

function removeLinhaCadastroManual(elm){
    jQuery(elm).parent().parent().remove();
    atualizarAlunosManualmente();
    botoesCadastroManual();
}

function atualizarAlunosManualmente(){
    alunos = [];
    var dados = jQuery('#form-manual-aluno').serialize().split('nome=');
    jQuery.each(dados, function(index, value){
        var arrValue = value.split('&email=');        
        if(arrValue[0] != ""){
            var nome = arrValue[0];
            var mail = arrValue[1];
            nome = nome.replace(/\+/g, " ");
            nome = nome.replace(/%20/g, " ");
            mail = mail.replace("&", "");
            mail = mail.replace("%40", "@");
            alunos.push({'nome': nome, 'email': mail, 'certificado': false, 'enviar': 'Não'});     
        }   
    });        
    verificaQtdAlunos();
    //atualiza passos 3 e 4
    verificaDadosCurso();    
    populaAlunosTabelaFinal();
    populaAlunosTabelaSucesso();
    contaCreditosAUtilizar();
}

function verificaDadosCurso(){
    palestraTitulo = jQuery('#form-dados-curso #curso').val();
    palestraProfessor = jQuery('#form-dados-curso #palestrante').val();
    palestraData = jQuery('#form-dados-curso #data').val();
    palestraLocal = jQuery('#form-dados-curso #local').val();
    palestraCargaHoraria = jQuery('#form-dados-curso #carga-horaria').val();
    if(palestraTitulo != "" && palestraData != "" && palestraCargaHoraria != ""){
        dadosCursoValidados = true;
        palestraTitulo = palestraTitulo.replace("\"","'");
        palestraProfessor = palestraProfessor.replace("\"","'");
        palestraData = palestraData.replace("\"","'");
        palestraLocal = palestraLocal.replace("\"","'");
        palestraCargaHoraria = palestraCargaHoraria.replace("\"","'");
    } else {
        dadosCursoValidados = false;
    }
    passosCompletos();
}

function populaAlunosTabelaFinal(){
    jQuery('#rodar-algoritmo table tbody tr.aluno').remove();
    var alunosInvertido = alunos.slice(0).reverse();
    jQuerynumAluno = alunosInvertido.length;
    jQuery.each(alunosInvertido, function(index, arrAluno){
        var elem = '<tr class="aluno">';

        elem += '<td>#' + jQuerynumAluno + '</td>';

        elem += '<td>';
        elem += arrAluno.nome;
        elem += '<div class="status">';
        elem += '<div class="texto">';
        elem += '<strong>Status: </strong>'
        if(!arrAluno.certificado) {
            elem += 'Aguardando';
        } else {
            elem += 'Certificado gerado';
        }    
        elem += '</div>';
        elem += '<div class="progress">';
        elem += '<div class="progress-bar progress-bar-striped active" role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100"></div>';
        elem += '</div>';
        elem += '</div>';
        elem += '<div class="gerar">';               
        if(jQuerynumAluno == 1) {     
            elem += '<button class="btn btn-sm btn-primary" onclick="gerarCertificadoAvulso(' + jQuerynumAluno + ')">';
            elem += '<span class="dashicons dashicons-awards"></span>Gerar teste';
            elem += '</button>'; 
        }
        elem += '</div>';
        elem += '</td>';

        elem += '<td>';
        var reg = /^\w+([-+.\']\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$/;
        if(arrAluno.email == "") {
            elem += '<input type="checkbox" disabled="disabled"> E-mail não informado';
        } else if(!reg.test(arrAluno.email)) {
            elem += '<input type="checkbox" disabled="disabled"> ';
            elem += arrAluno.email;
            elem += ' <span class="label label-danger">inválido</span>';
        } else {
            elem += '<input type="checkbox" class="emailEnvio" checked="checked" onclick="contaCreditosAUtilizar();" value="' + jQuerynumAluno + '"> ';
            elem += arrAluno.email;
        }                
        elem += '</td>';

        elem += '</tr>';
        jQuery(elem).prependTo('#rodar-algoritmo table tbody');
        jQuerynumAluno = jQuerynumAluno-1;
    });
}

function populaAlunosTabelaSucesso(){
    jQuery('#sucesso table tbody tr.aluno').remove();
    var alunosInvertido = alunos.slice(0).reverse();
    jQuerynumAluno = alunosInvertido.length;
    jQuery.each(alunosInvertido, function(index, arrAluno){
        var elem = '<tr class="aluno">';
        elem += '<td>#' + jQuerynumAluno + '</td>';
        elem += '<td>' + arrAluno.nome + '</td>';
        elem += '<td class="cert"></td>';
        elem += '</tr>';
        jQuery(elem).prependTo('#sucesso table tbody');
        jQuerynumAluno = jQuerynumAluno-1;
    });
}

function selectEnviarTodosCertificados(elm){
    if(jQuery(elm).is(":checked")){
        jQuery('input.emailEnvio').prop('checked', true);
    } else {
        jQuery('input.emailEnvio').prop('checked', false);
    }
    contaCreditosAUtilizar();
}

function selectEnviarCertificado(elm){
    contaCreditosAUtilizar();
}

function contaCreditosAUtilizar(){
    var numCreditosEmissao = qtdAlunos;
    var numCreditosEnvio = 0
    var numCreditos = 0
    jQuery('input.emailEnvio').each(function(){
        if(jQuery(this).is(":checked")){
            alunos[jQuery(this).val()-1].enviar = "Sim";
            numCreditosEnvio++;
        } else {
            alunos[jQuery(this).val()-1].enviar = "Não";
        }        
    });
    numCreditos = numCreditosEmissao + numCreditosEnvio;
    if(numCreditos > 0){
        jQuery('.aplicacao #rodar-algoritmo table tr.creditos').show();
        if(numCreditosEmissao > 0) {
            jQuery('p#qtdCreditosAUtilizar-emissao').show();
            jQuery('p#qtdCreditosAUtilizar-emissao span').html(numCreditosEmissao);
        } else {
            jQuery('p#qtdCreditosAUtilizar-emissao').hide();
        }
        if(numCreditosEnvio > 0) {
            jQuery('p#qtdCreditosAUtilizar-envio').show();
            jQuery('p#qtdCreditosAUtilizar-envio span').html(numCreditosEnvio);
        } else {
            jQuery('p#qtdCreditosAUtilizar-envio').hide();
        }
    } else {
        jQuery('input#enviarTodos').prop('checked', false);
        jQuery('.aplicacao #rodar-algoritmo table tr.creditos').hide();
    }
    if(numCreditos > saldoUsuario){
        jQuery('.aplicacao #rodar-algoritmo table tr.alerta').show();
        jQuery('p#faltaCreditos span').html(saldoUsuario);
        jQuery('.aplicacao .abas .aba .acoes #btn-gerar-todos').addClass('desabilitado').removeAttr('onclick');        
    } else {
        jQuery('.aplicacao #rodar-algoritmo table tr.alerta').hide();
        jQuery('.aplicacao .abas .aba .acoes #btn-gerar-todos').removeClass('desabilitado').attr('onclick','iniciarGerarEmLote()');
    }
}

function gerarCertificadoAvulso(numNaLista){
    //valida infos
    if(idModeloSelecionado == 0){
        alert('Antes de gerar certificados, você precisa definir um modelo (passo 1)');
        return false;
    } else if(qtdAlunos == 0){
        alert('Antes de gerar certificados, você precisa definir a lista de alunos (passo 2)');
        return false;
    } else if(!dadosCursoValidados){
        alert('Antes de gerar certificados, você precisa informar os dados do curso (passo 3)');
        return false;
    } else if(saldoUsuario == 0 && tcert == 'validado'){
        alert('Infelizmente seu saldo de créditos chegou a zero. Você precisa adquirir mais créditos para emitir certificados via plugin');
        return false;
    }
    if(gerando == false) {
        gerando = true;
        jQuery('#rodar-algoritmo table tr:nth-child(' + numNaLista + ') .status .texto').hide();
        jQuery('#rodar-algoritmo table tr:nth-child(' + numNaLista + ') .status .progress').css('display', 'flex');
        setTimeout(function(){
            jQuery('#rodar-algoritmo .progress-bar.active').css({width: '50%'});
        }, 100);
        setTimeout(function(){
            jQuery('#rodar-algoritmo .progress-bar.active').css({width: '100%'});
        }, 1000);
        setTimeout(function(){     
            var url = urlBaseApi + "create/test/V1/";
            var data = { idModeloCertificado: idModeloSelecionado, nome: alunos[numNaLista-1].nome, titulo: palestraTitulo, professor: palestraProfessor, data: palestraData, local: palestraLocal, cargaHoraria: palestraCargaHoraria };
            if(tcert == 'validado'){
                url = urlBaseApi + "create/valid/V1/";
                data = { idModeloCertificado: idModeloSelecionado, nome: alunos[numNaLista-1].nome, email: alunos[numNaLista-1].email, enviar: alunos[numNaLista-1].enviar, titulo: palestraTitulo, professor: palestraProfessor, data: palestraData, local: palestraLocal, cargaHoraria: palestraCargaHoraria };
            }
                 
            jQuery.ajax({
                type: "POST",
                url: url,
                beforeSend: function (xhr) {
                    xhr.setRequestHeader("Authorization", "Basic " + getToken());
                },
                data: data,
            }).done(function(data) {
                var b64 = data.fileBase64;
                b64 = b64.replace('data:application/pdf;base64,','');
                alunos[numNaLista-1].certificado = b64;
                jQuery('#rodar-algoritmo table tr:nth-child(' + numNaLista + ') .status .texto').html('<strong>Status: </strong><a id="link-download-teste" download="certificado (' + alunos[numNaLista-1].nome + ').pdf" href="data:application/octet-stream;base64,' + b64 +'">Certificado gerado</a>').show();
                jQuery('#rodar-algoritmo table tr:nth-child(' + numNaLista + ') .status .progress').hide();
                jQuery('#rodar-algoritmo .progress-bar.active').css({width: '0'});
                jQuery('#sucesso table tr:nth-child(' + numNaLista + ') .cert').html('<a id="link-download-teste" download="certificado (' + alunos[numNaLista-1].nome + ').pdf" href="data:application/octet-stream;base64,' + b64 +'">Download certificado (' + alunos[numNaLista-1].nome + ').pdf</a>').show();
                contaCreditosAUtilizar();
                gerando = false;
                if(gerandoLote){
                    jQuery('.aplicacao #rodar-algoritmo table tr.creditos, .aplicacao #rodar-algoritmo table tr.alerta').hide();
                    jQuery('input#enviarTodos').remove();
                    jQuery('input[type="checkbox"]').prop('disabled', true);
                    gerarTodosCertificados(numNaLista+1);
                    getSaldoUsuario();
                } else {
                    jQuery('#link-download-teste')[0].click();
                }
            }).fail(function() {
                solicitaLogin();
            });
        }, 1000);
    }
}

function iniciarGerarEmLote(){
    if(jQuery('#ciencia-1').is(":checked") && jQuery('#ciencia-2').is(":checked")){
        gerandoLote = true;
        tcert = 'validado';
        jQuery('.title-abas').remove();
        jQuery('.nav-abas').remove();
        jQuery('.aplicacao .abas .aba .acoes').remove();
        jQuery('.aplicacao #rodar-algoritmo table tr.creditos, .aplicacao #rodar-algoritmo table tr.alerta').hide();
        jQuery('input#enviarTodos').remove();
        jQuery('input[type="checkbox"]').prop('disabled', true);       
        gerarTodosCertificados(1);
    } else {
        alert('Para iniciar a emissão você precisa informar que está ciente dos itens informados acima.');
    }
}

function gerarTodosCertificados(numNaLista){
    if(gerandoLote) {
        jQuery('.aplicacao table .gerar').remove();
        if(jQuery('#rodar-algoritmo table tr:nth-child(' + numNaLista + ') .status .texto').length){
            gerarCertificadoAvulso(numNaLista);
        } else {
            gerandoLote = false;
            selecionaPasso(5);
        }
    }
}